var DGT = DGT || {}
DGT.MVDF = DGT.MVDF || {}
DGT.MVDF.protocols = DGT.MVDF.protocols || {}
{
  const name = {
    armor:i=> ($dataArmors[i] && $dataArmors[i].name) || `Armor ${i}`,
    weapon:i=> ($dataWeapons[i] && $dataWeapons[i].name) || `Weapon ${i}`,
    item:i=> ($dataItems[i] && $dataItems[i].name) || `Item ${i}`,
    actor:i=> ($dataActors[i] && $dataActors[i].name) || `Actor ${i}`,
    state:i=> ($dataStates[i] && $dataStates[i].name) || `State ${i}`,
    skill:i=> ($dataSkills[i] && $dataSkills[i].name) || `Skill ${i}`,
    enemy:i=> ($dataEnemies[i] && $dataEnemies[i].name) || `Enemy ${i}`,
    cl:i=> ($dataClasses[i] && $dataClasses[i].name) || `Class ${i}`,
    cevent:i=>($dataCommonEvents[i] && $dataCommonEvents[i].name) || `CEVENT #${i}`,
    label:i=>`${i}`,
    variable:i=>`${$dataSystem.variables[i] || `V#${i}`}`,
    selfvariable:(i,list)=>`SV#${list&&list[i]||i}`,
    switch:i=>`${$dataSystem.switches[i] || `S#${i}`}`,
    selfswitch:i=>`${i}`,
    langmsg:i=>`${i}`,
    variableselect:function(start, end){
      for (let i=start;i<=end;i++) {this.variable(i)} // required for proper searching of variables within ranges
      return `${this.variable(start)}..${this.variable(end)}`
    },
    switchselect:function(start, end){
      for (let i=start;i<=end;i++) {this.switch(i)}
      return `${this.switch(start)}..${this.switch(end)}`
    },
    anim:i=> ($dataAnimations[i] && $dataAnimations[i].name) || `Anim ${i}`,
    time:(t,u)=>t==0?'Instant':`${t} ${u}${t!=1?'s':''}`,
    sound:s=>`${s.name||'None'}${s.volume!==90?` Volume:${s.volume}`:''}${s.pitch!==100?` Pitch:${s.pitch}`:''}${s.pan!==0?` Volume:${s.pan}`:''}`
  }
  function makeLink(proto, id, text, cvar) {
    if (!cvar) {cvar = 'noop'}
    return `<a data-fq="${proto}:${id}" href="#" style="color:var(--${cvar})">${text}</a>`
  }
  const link = {
    variable:i=>makeLink('var', i, name.variable(i), 'state'),
    switch:i=>makeLink('switch', i, name.switch(i), 'state'),
    variableselect:(i, end)=>makeLink('variableselect', `${i}:${end}`, name.variableselect(i, end), 'state'),
    switchselect:(i, end)=>makeLink('switchselect', `${i}:${end}`, name.switchselect(i, end), 'state'),
    cevent:i=>makeLink('cevent', i, name.cevent(i), 'flow'),
    label:i=>`<a data-fq="label:label_${i}" href="#" style="color:var(--flow)">${name.label(i)}</a>`,
    langmsg:i=>makeLink('langmsg', i, name.langmsg(i), 'special')
  }
  const range = function*(start, end, inc = 1) {for (let i = start; i <= end; i+=inc) {yield i}}
  DGT.MVDF.protocols.switchselect = (x)=>{
    let [start, end] = x.split(':').map(n=>parseInt(n))
    DGT.MVDF.view.history.storeScroll()
    updateCodeView(range(start, end), link.switch, ()=>'var(--flow)')
  }
  DGT.MVDF.protocols.variableselect = (x)=>{
    let [start, end] = x.split(':').map(n=>parseInt(n))
    DGT.MVDF.view.history.storeScroll()
    updateCodeView(range(start, end), link.variable, ()=>'var(--flow)')
  }

  const actorEx = i=>`${i?name.actor(i):'Entire Party'}`
  const enemyEx = i=>`${i>=0?`Enemy #${i+1}`:'Entire Troop'}`
  const opValue = (op, type, val)=>`${op?'-':'+'} ${type?link.variable(val):val}`
  
  const comp = ['==','>=','<=','>','<','!=']
  const goldComp = ['>=', '<=', '<']
  const aops = ['=','+=','-=','*=','/=','%=']
  const dirs = ['_0','_1','DOWN','_3','LEFT','_5','RIGHT','_7','UP']
  const vehicles = {0:'Boat', 1:'Ship', 2:'Airship', boat:'Boat', ship:'Ship', airship:'Airship'} // yeah
  const weathers = {0:'None', 1:'Rain', 2:'Storm', 3:'Snow', none:'None', rain:'Rain', storm:'Storm', snow:'Snow'}
  const otherTypes = ['Map ID','Party Members','Gold','Steps','Playtime','Timer','Save Count','Battle Count','Win Count','Escape']
  const params = ['Max HP','Max MP','Attack','Defense','M.Attack','M.Defense','Agility','Luck']
  const statTypes = ['EXP','HP','MP', ...params]
  const actorStatTypes = ['Level',...statTypes]
  const speeds = ['', '8x Slower', '4x Slower', '2x Slower', 'Normal', '2x Faster', '4x Faster']
  const freqs = ['', 'Lowest', 'Lower', 'Normal', 'Higher', 'Highest']
  const blends = ['Normal', 'Add', 'Multiply', 'Screen']
  const equipForActorSlotAndID = (actor, slot, id) => {
    const cl = $dataClasses[$dataActors[actor].classId]
    return cl.equipSlots[slot-1]===1?name.weapon(id):name.armor(id)
  }
  const eventify = e=>['Player', 'This Event'][e+1]||`Event #${e}`
  const targetify = t=>['Last Target', 'Random'][t+2]||`Index #${t}`
  const eventDataTypes = ['Map X', 'Map Y', 'Direction', 'Screen X', 'Screen Y']
  const gameDataOperand = function(p4,p5,p6) {
    switch(p4) {
      case 0: return `#Owned ${name.item(p5)}`
      case 1: return `#Owned ${name.weapon(p5)}`
      case 2: return `#Owned ${name.armor(p5)}`
      case 3: return `${actorStatTypes[p6]} of ${name.actor(p5)}`
      case 4: return `${statTypes[p6]} of Enemy #${p5+1}`
      case 5: return `${eventDataTypes[p6]} of ${eventify(p5)}`
      case 6: return `Actor ID of Member #${p5+1}`
      case 7: return `${otherTypes[p5]}`
    }
  }
  const defer = {
    route:({code, parameters: p})=>{
      switch(code) {
        case 0: return `-`
        case 1: return `MOVE DOWN`
        case 2: return `MOVE LEFT`
        case 3: return `MOVE RIGHT`
        case 4: return `MOVE UP`
        case 5: return `MOVE LOWER L`
        case 6: return `MOVE LOWER R`
        case 7: return `MOVE UPPER L`
        case 8: return `MOVE UPPER R`
        case 9: return `MOVE RANDOM`
        case 10: return `MOVE TOWARD PLAYER`
        case 11: return `MOVE AWAY FROM PLAYER`
        case 12: return `MOVE FORWARD`
        case 13: return `MOVE BACKWARD`
        case 14: return `JUMP: ${p[0]}, ${p[1]}`
        case 15: return `WAIT: ${name.time(p[0], 'frame')}`
        case 16: return `TURN DOWN`
        case 17: return `TURN LEFT`
        case 18: return `TURN RIGHT`
        case 19: return `TURN UP`
        case 20: return `TURN 90D R`
        case 21: return `TURN 90D L`
        case 22: return `TURN 180D`
        case 23: return `TURN 90D R L`
        case 24: return `TURN RANDOM`
        case 25: return `TURN TOWARD PLAYER`
        case 26: return `TURN AWAY FROM PLAYER`
        case 27: return `SWITCH ${p[0]}: On`
        case 28: return `SWITCH ${p[0]}: Off`
        case 29: return `CHANGE SPEED: ${speeds[p[0]]}`
        case 30: return `CHANGE FREQ: ${freqs[p[0]]}`
        case 31: return `WALK ANIME: On`
        case 32: return `WALK ANIME: Off`
        case 33: return `STEP ANIME: On`
        case 34: return `STEP ANIME: Off`
        case 35: return `DIR FIX: On`
        case 36: return `DIR FIX: Off`
        case 37: return `THROUGH: On`
        case 38: return `THROUGH: Off`
        case 39: return `TRANSPARENT: On`
        case 40: return `TRANSPARENT: Off`
        case 41: return `CHANGE IMAGE: ${p[0]}, ${p[1]}`
        case 42: return `CHANGE OPACITY: ${p[0]}`
        case 43: return `CHANGE BLEND MODE: ${blends[p[0]]}`
        case 44: return `PLAY SE: ${name.sound(p[0])}`
        case 45: return `SCRIPT: <span style="color:var(--eval)">${p[0]}<span>`
      }
    },
    //101:()=>{}// SHOW TEXT
    102:p=>{
      return p[0].join(', ')
    },
    x111:(a, b)=>{
      switch(a) {
        case 0: return 'is in party'
        case 1: return `is named ${b}`
        case 2: return `is class ${name.cl(b)}`
        case 3: return `learned ${name.skill(b)}`
        case 4: return `equipped ${name.weapon(b)}`
        case 5: return `equipped ${name.armor(b)}`
        case 6: return `is affected by ${name.state(b)}`
      }
    },
    111:function(p, svl) {// IF
      switch(p[0]) {
        case 0:  return `${link.switch(p[1])} is ${p[2]?'OFF':'ON'}`
        case 1:  return `${link.variable(p[1])} ${comp[p[4]]} ${p[2]?link.variable(p[3]):p[3]}`
        case 2:  return `Self Switch ${p[1]} is ${p[2]?'OFF':'ON'}`
        case 3:  return `Timer ${p[2]?'<=':'>='} ${p[1]}`
        case 4:  return `${name.actor(p[1])} ${this.x111(p[2], p[3])}`
        case 5:  return `Enemy #${p[1]+1} ${p[2]?`is affected by ${name.state(p[3])}`:'has appeared'}`
        case 6:  return `${eventify(p[1])} is facing ${dirs[p[2]]||'??'}`
        case 7:  return `Party Gold ${goldComp[p[2]]} ${p[1]}`
        case 8:  return `Party Has Item ${name.item(p[1])}`
        case 9:  return `Party Has Weapon ${name.weapon(p[1])}${p[2]?' (include equip)':''}`
        case 10: return `Party Has Armor ${name.armor(p[1])}${p[2]?' (include equip)':''}`
        case 11: return `Button ${`${p[1]}`.toUpperCase()} is pressed`
        case 12: return `<span style="color:var(--eval)">${p[1]}<span>`
        case 13: return `${vehicles[p[1]]} is driven`
        case 14: return `${name.selfvariable(p[1], svl)} ${comp[p[4]]} ${p[2]===2?name.selfvariable(p[3], svl):p[2]?link.variable(p[3]):p[3]}`
        default: return p.join(', ')
      }
    },
    117:p=>{// COMMON EVENT
      return link.cevent(p[0])
    },
    118:p=>{// LABEL
      return `<span id='label_${p[0]}'>${p[0]}</span>`
    },
    119:p=>{// GO TO LABEL
      return link.label(p[0])
    },
    121:p=>{// CONTROL SWITCHES
      return `${p[0]===p[1]?link.switch(p[0]):`${link.switchselect(p[0], p[1])}`} = ${p[2]?'OFF':'ON'}`
    },
    122:p=>{// CONTROL VARIABLES
      let last
      switch(p[3]) {
        case 0: last = p[4]; break;
        case 1: last = link.variable(p[4]); break;
        case 2: last = `rand?${p[4]}..${p[5]}?`; break;
        case 3: last = gameDataOperand(p[4],p[5],p[6]); break;
        case 4: last = `<span style="color:var(--eval)">${p[4]}<span>`; break;
      }
      return `${p[0]===p[1]?link.variable(p[0]):`${link.variableselect(p[0], p[1])}`} ${aops[p[2]]} ${last}`
    },
    123:p=>{// CONTROL SELF SWITCH
      return `${p[0]} = ${p[1]?'OFF':'ON'}`
    },
    125:p=>{// CHANGE GOLD
      return `${p[0]?'-':'+'} ${p[1]?name.variable(p[2]):p[2]}`
    },
    126:p=>{// CHANGE ITEM
      return `${name.item(p[0])} ${p[1]?'-':'+'} ${p[2]?name.variable(p[3]):p[3]}`
    },
    127:p=>{// CHANGE WEAPONS
      return `${name.weapon(p[0])} ${p[1]?'-':'+'} ${p[2]?name.variable(p[3]):p[3]}${p[4]&&p[1]?' (include equip)':''}`
    },
    128:p=>{// CHANGE ARMORS
      return `${name.armor(p[0])} ${p[1]?'-':'+'} ${p[2]?name.variable(p[3]):p[3]}${p[4]&&p[1]?' (include equip)':''}`
    },
    129:p=>{// CHANGE ACTORS
      return `${p[1]?'REMOVE':'ADD'} ${name.actor(p[0])}${p[2]?' (Initialize)':''}`
    },
    132:p=>{// BATTLE BGM
      return name.sound(p[0])
    },
    135:p=>{// MENU ACCESS
      return `${p[0]?'ON':'OFF'}`
    },
    205:p=>{// SET MOVEMENT ROUTE
      const {repeat, skip, wait} = p[1]
      const settings = [repeat&&'repeat', skip&&'skip', wait&&'wait'].filter(x=>x)
      //LINKIFY THIS LATER OR SOMETHING
      return `${eventify(p[0])}${settings.length > 0?` (${settings.join(', ')})`:''}`
    },
    211:p=>{// TRANSPARENCY
      return `${p[0]?'OFF':'ON'}`
    },
    212:p=>{
      return `${eventify(p[0])}, ${name.anim(p[1])}${p[2]?' (wait)':''}`
    },
    216:p=>{// CHANGE FOLLOWERS
      return `${p[0]?'OFF':'ON'}`
    },
    225:p=>{// SHAKE SCREEN
      return `Power: ${p[0]}, Speed: ${p[1]}, ${name.time(p[2], 'frame')}${p[3]?' (wait)':''}`
    },
    223:p=>{// TINT SCREEN
      return `(${p[0]}), ${name.time(p[1], 'frame')}${p[2]?' (wait)':''}`
    },
    230:p=>{// WAIT
      return name.time(p[0], 'frame')
    },
    236:p=>{// WEATHER EFFECT
      return `${weathers[p[0]]}, Power: ${p[1]}, ${name.time(p[2], 'frame')}${p[3]?' (wait)':''}`
    },
    241:p=>{// PLAY BGM
      return `${name.sound(p[0])}${p[1]?`, Fade in: ${name.time(p[1], 'second')}`:''}`
    },
    242:p=>{// FADE OUT BGM
      return name.time(p[0], 'second')
    },
    245:p=>{// PLAY BGS
      return name.sound(p[0])
    },
    246:p=>{// FADE OUT BGM
      return name.time(p[0], 'second')
    },
    249:p=>{// PLAY ME
      return name.sound(p[0])
    },
    250:p=>{// PLAY SE
      return name.sound(p[0])
    },
    x3x:(p0,p1,p2,p3,p4)=>{// internal generalized function for party stat changes
      return `${p0?link.variable(p1):actorEx(p1)} ${opValue(p2,p3,p4)}`
    },
    311:function(p){// CHANGE HP
      return this.x3x(...p) + ' HP'
    },
    312:function(p){// CHANGE MP
      return this.x3x(...p) + ' MP'
    },
    313:function(p){// CHANGE STATE
      return this.x3x(p[0],p[1],p[2],0,name.state(p[3]))
    },
    314:function(p){// RECOVER ALL
      return `${p[0]?link.variable(p[1]):actorEx(p[1])}`
    },
    315:function(p){ // CHANGE EXP
      return `${this.x3x(...p)} EXP${p[5]?' (show level up)':''}`
    },
    316:function(p){ // CHANGE LEVEL
      return `${this.x3x(...p)} LVL${p[5]?' (show level up)':''}`
    },
    317:function(p){ // CHANGE PARAM
      return `${this.x3x(p[0],p[1], p[3],p[4],p[5])} ${params[p[2]]}`
    },
    318:function(p){// CHANGE SKILL
      return this.x3x(p[0],p[1],p[2],0,name.skill(p[3]))
    },
    319:function(p){// CHANGE EQUIP (I HATE THE DUEL WIELD SYSTEM)
      return `${actorEx(p[0])}, ${$dataSystem.equipTypes[p[1]]} = ${equipForActorSlotAndID(p[0], p[1], p[2])}`
    },
    320:function(p){// CHANGE NAME
      return `${actorEx(p[0])}, ${p[1]}`
    },
    321:function(p){// CHANGE CLASS
      return `${actorEx(p[0])}, ${name.cl(p[1])}${p[2]?' (save level)':''}`
    },
    324:function(p){// CHANGE NICKNAME
      return `${actorEx(p[0])}, ${p[1]}`
    },
    326:function(p){// CHANGE TP
      return this.x3x(...p) + ' TP'
    },
    331:function(p){// CHANGE ENEMY HP
      return `${enemyEx(p[0])} ${opValue(p[1],p[2],p[3])} HP${p[4]?' (allow knockout)':''}`
    },
    332:function(p){// CHANGE ENEMY MP
      return `${enemyEx(p[0])} ${opValue(p[1],p[2],p[3])} MP`
    },
    333:function(p){// CHANGE ENEMY STATE
      return `${enemyEx(p[0])} ${opValue(p[1],0,name.state(p[2]))}`
    },
    334:function(p){// ENEMY RECOVER ALL
      return `${enemyEx(p[0])}`
    },
    335:function(p){// ENEMY APPEAR
      return `${enemyEx(p[0])}`
    },
    336:function(p){// ENEMY TRANSFORM
      return `${enemyEx(p[0])}, ${name.enemy(p[1])}`
    },
    337:function(p){// ENEMY ANIMATION
      return `${enemyEx(p[2]?-1:p[0])}, ${name.anim(p[1])}`
    },
    339:function(p){
      return `${p[0]?name.actor(p[1]):`Enemy #${p[1]+1}`}, ${name.skill(p[2])}, ${targetify(p[3])}`
    },
    342:function(p){// CHANGE ENEMY TP
      return `${enemyEx(p[0])} ${opValue(p[1],p[2],p[3])} TP`
    },
    355:function(p){// EVAL SCRIPT (first line)
      return `${p[0]}`.replace(/(\$gameSwitches\.(?:set)?[vV]alue\()(\d+)/g, (_, $1, $2)=>`${$1}${link.switch($2)}`)
                      .replace(/(\$gameVariables\.(?:set)?[vV]alue\()(\d+)/g, (_, $1, $2)=>`${$1}${link.variable($2)}`)
    },
    356:function(p){// PLUGIN COMMAND
      let args = p[0].split(' ')
      let [cmd, data, ...rest] = args
      if (cmd === 'ShowMessage' || cmd === 'AddChoice') {
        return `${cmd} ${link.langmsg(data)} ${rest.join(' ')}`
      }
      return p[0]
    },
    357:function(p, svl){// CONTROL SELF VARIABLE
      let last
    	switch(p[3]) {
        case 0: last = p[4]; break;
        case 1: last = link.variable(p[4]); break;
        case 2: last = `rand?${p[4]}..${p[5]}?`; break;
        case 3: last = gameDataOperand(p[4],p[5],p[6])
        case 4: last = `<span style="color:var(--eval)">${p[4]}<span>`; break;
        case 5: last = name.selfvariable(p[4], svl); break;
      }
    	return `${p[0]===p[1]?name.selfvariable(p[0], svl):`${name.selfvariable(p[0], svl)}..${name.selfvariable(p[1], svl)}`} ${aops[p[2]]} ${last}`
    },
    402:p=>{// CHOICE BRANCE
      return ` ${p[1]}:`
    },
    505:function(p){// MOVE ROUTE CONTINUED
      return this.route(p[0])
    },
    655:function(p){// EVAL SCRIPT (continued)
      return this[355](p)
    },
  }
  const codes = JSON.parse('{"0":"-","101":"SHOW TEXT:","102":"SHOW CHOICES:","108":"//","111":"IF:","112":"LOOP","113":"BREAK","115":"EXIT EVENT PROCESSING","117":"COMMON EVENT:","118":"LABEL:","119":"GO TO LABEL:","121":"CTRL SWITCH:","122":"CTRL VAR:","123":"CTRL SELFSW:","125":"CHANGE GOLD","126":"CHANGE ITEM:","127":"CHANGE WEAPONS:","128":"CHANGE ARMORS:","129":"CHANGE PARTY:","132":"BATTLE BGM:","135":"MENU ACCESS:","205":"SET ROUTE:","211":"TRANSPARENCY:","212":"SHOW ANIMATION:","214":"ERASE EVENT","216":"CHANGE FOLLOWERS:","221":"FADEOUT SCREEN","222":"FADEIN SCREEN","223":"TINT:","225":"SHAKE SCREEN: ","230":"WAIT:","231":"SHOW PIC:","232":"MOVE PIC:","235":"ERASE PIC:","236":"WEATHER EFFECT:","241":"PLAY BGM:","242":"FADE OUT BGM:","243":"SAVE BGM","244":"REPLAY BGM","245":"PLAY BGS:","246":"FADE OUT BGS:","249":"PLAY ME:","250":"PLAY SE:","251":"STOP SE","261":"PLAY MOVIE:","311":"CHANGE HP:","313":"CHANGE STATE:","314":"RECOVER ALL:","318":"CHANGE SKILL:","319":"CHANGE EQUIP:","331":"CHANGE HP:","333":"CHANGE STATE:","334":"RECOVER ALL:","335":"ENEMY APPEAR:","336":"TRANSFORM:","337":"SHOW ANIM:","339":"FORCE ACTION:","340":"ABORT BATTLE","353":"GAME OVER","355":"EVAL:","356":"PCMD:","357":"CTRL SELFVAR:","401":"         :","402":"WHEN","403":"WHEN CANCEL:","404":"END","408":"//","411":"ELSE:","412":"END","413":"REPEAT ABOVE","505":"         :","655":"    :","params":{"0":[],"101":["","","",""],"102":["","","","",""],"108":[""],"112":[],"113":[],"115":[],"123":[],"125":[],"126":["","","",""],"129":[],"132":["Params: ",""],"135":[],"205":[],"211":[],"216":[],"221":[],"222":[],"231":["#","","","","","","","","",""],"232":["#","","","","","","","","","","",""],"235":["#"],"236":["Params: ","","",""],"243":[],"244":[],"249":[],"251":[],"261":[""],"314":[],"319":[],"340":[],"353":[],"401":[""],"402":["",""],"404":[],"408":[""],"411":[],"412":[],"413":[],"505":[]}}')
  const colors = JSON.parse('{"0":"var(--noop)","101":"var(--special)","102":"var(--special)","108":"var(--noop)","111":"var(--flow)","112":"var(--flow)","113":"var(--flow)","115":"var(--flow)","117":"var(--flow)","118":"var(--flow)","119":"var(--flow)","121":"var(--state)","122":"var(--state)","123":"var(--state)","125":"var(--party)","126":"var(--party)","127":"var(--party)","128":"var(--party)","129":"var(--party)","132":"var(--battle)","135":"var(--special)","205":"var(--move)","211":"var(--move)","212":"var(--move)","214":"var(--move)","216":"var(--move)","221":"var(--vfx)","222":"var(--vfx)","223":"var(--vfx)","225":"var(--vfx)","230":"var(--delay)","231":"var(--pic)","232":"var(--pic)","235":"var(--pic)","236":"var(--vfx)","241":"var(--sfx)","242":"var(--sfx)","243":"var(--sfx)","244":"var(--sfx)","245":"var(--sfx)","246":"var(--sfx)","249":"var(--sfx)","250":"var(--sfx)","251":"var(--sfx)","261":"var(--special)","311":"var(--party)","313":"var(--party)","314":"var(--party)","318":"var(--party)","319":"var(--party)","331":"var(--battle)","333":"var(--battle)","334":"var(--battle)","335":"var(--battle)","336":"var(--battle)","337":"var(--battle)","339":"var(--battle)","340":"var(--battle)","353":"var(--battle)","355":"var(--eval)","356":"var(--special)","357":"var(--special)","401":"var(--special)","402":"var(--special)","404":"var(--special)","408":"var(--noop)","411":"var(--flow)","412":"var(--flow)","413":"var(--flow)","505":"var(--move)","655":"var(--eval)"}')
  const ceventTriggers = ['None', 'Autorun', 'Parallel']
  const triggers = ['Action Button', 'Player Touch', 'Event Touch', 'Autorun', 'Parallel']
  const spans = ['Battle', 'Turn', 'Moment']
  const meta = {
    'trigger': (kv, event)=>{
      kv[1] = (event.image?triggers:ceventTriggers)[kv[1]] || kv[1]
      return kv
    },
    'switchId': (kv, event)=>{
      if (event && event.trigger) {
        kv[1] = link.switch(kv[1])
      } else {
        kv[1] = 'None'
      }
      return kv
    },
    'selfVariables': (kv)=>{
      kv[1] = `[${kv[1].filter(e=>e).join(', ')}'`
      return kv
    },
    'span': (kv)=>{
      kv[1] = spans[kv[1]]
      return kv
    },
    'members': (kv)=>{
      kv[1] = Object.assign({}, kv[1].map(e=>({...e, enemyId:`${e.enemyId} (${name.enemy(e.enemyId)})`})))
      return kv
    },
    'conditions': (kv, event)=>{
      let conditions = {}
      let sz = 0
      if (event.span !== undefined) { // battle conditions
        if (kv[1].turnEnding) {conditions[sz++] = 'Turn Ending'}
        if (kv[1].turnValid) {conditions[sz++] = `Turn ${kv[1].turnB?`${kv[1].turnA?`${kv[1].turnA}+`:''}${kv[1].turnB}*X`:`${kv[1].turnA}`}`}
        if (kv[1].enemyValid) {conditions[sz++] = `Enemy HP (${kv[1].enemyIndex+1}) <= ${kv[1].enemyHp}%`}
        if (kv[1].actorValid) {conditions[sz++] = `Enemy HP (${name.actor(kv[1].actorId)}) <= ${kv[1].actorHp}%`}
        if (kv[1].switchValid) {conditions[sz++] = `${link.switch(kv[1].switchId)} is ON`}
        return ['conditions', sz?conditions:'Don\'t Run']
      }
      if (kv[1].actorValid) {conditions[sz++] = `${name.actor(kv[1].actorId)} is in party`}
      if (kv[1].itemValid) {conditions[sz++] = `Party has ${name.item(kv[1].itemId)}`}
      if (kv[1].selfSwitchValid) {conditions[sz++] = `Self Switch ${name.selfswitch(kv[1].selfSwitchCh)} is ON`}
      if (kv[1].switch1Valid) {conditions[sz++] = `${link.switch(kv[1].switch1Id)} is ON`}
      if (kv[1].switch2Valid) {conditions[sz++] = `${link.switch(kv[1].switch2Id)} is ON`}
      if (kv[1].variableValid) {conditions[sz++] = `${link.variable(kv[1].variableId)} >= ${kv[1].variableValue}`}
      if (kv[1].scriptValid) {conditions[sz++] = '-SCRIPT CONDITION-'}
      if (kv[1].selfVariableValid) {conditions[sz++] = `${name.selfvariable(kv[1].selfVariableId, event.selfVariables)} >= ${kv[1].selfVariableValue}`}
      return ['conditions', sz?conditions:'none']
    }
  }
  DGT.MVDF.translate = {
    name,
    makeLink,
    link,
    defer,
    codes,
    colors,
    meta
  }
}