var DGT = DGT || {}
DGT.MVDF = DGT.MVDF || {}
DGT.MVDF.filters = {}
{
  console.log('q')
  const codeUsesName = function(code, id, n) {
    if (!DGT.MVDF.translate.defer[code.code]) {return false}
    let uses = false
    let old_name = DGT.MVDF.translate.name[n]
    DGT.MVDF.translate.name[n] = (i)=>{
      if (i == id) {uses = true}
      return ''
    }
    DGT.MVDF.translate.defer[code.code](code.parameters)
    DGT.MVDF.translate.name[n] = old_name
    return uses
  }
  const pageUsesName = function(page, id, name) {
    if (!page) {return false}
    id = parseInt(id)
    return page.list.some(x=>codeUsesName(x, id, name))
  }
  const pageUsesVar = function(page, id) {
    if (!page) {return false}
    id = parseInt(id)
    if (page.conditions) {
      if (page.conditions.variableValid && page.conditions.variableId === id) {
        return true
      }
    }
    return pageUsesName(page, id, 'variable')
  }
  const pageUsesCode = function(page, code, params) {
    if (!page) {return false}
    code = parseInt(code)
    return page.list.some(x=>x.code === code && params.every((p, i)=>{return `${x.parameters[i]}`.toLowerCase().startsWith(`${p}`.toLowerCase())}))
  }
  const eventUsesVar = function(event, id) {
    if (!event) {return false}
    return event.pages.some(x=>pageUsesVar(x, id))
  }
  const pageUsesSwitch = function(page, id) {
    if (!page) {return false}
    id = parseInt(id)
    if (page.conditions) {
      if ((page.conditions.switch1Valid && page.conditions.switch1Id === id)||
          (page.conditions.switch2Valid && page.conditions.switch2Id === id)) {
        return true
      }
    }
    return pageUsesName(page, id, 'switch')
  }
  const eventUsesSwitch = function(event, id) {
    if (!event) {return false}
    return event.pages.some(x=>pageUsesSwitch(x, id))
  }
  const eventUsesCode = function(event, code, params) {
    if (!event) {return false}
    return event.pages.some(x=>pageUsesCode(x, code, params))
  }
  // let ach = `$gameSystem.unlockAchievement("${RegExp.$1}`
  // let ach2 = `$gameSystem.unlockAchievement('${RegExp.$1}`
  // (DGT.MVDF.filters.event.usesCode(src, 355, [ach]) //this is stupid
  //                                 || DGT.MVDF.filters.event.usesCode(src, 655, [ach])
  //                                 || DGT.MVDF.filters.event.usesCode(src, 355, [ach2])
  //                                 || DGT.MVDF.filters.event.usesCode(src, 655, [ach2]))
  const pageUsesAch = function(pg, ach) {
    if (!pg) {return false}
    let achv1 = `$gameSystem.unlockAchievement("${ach}`
    let achv2 = `$gameSystem.unlockAchievement('${ach}`
    return (
      pageUsesCode(pg, 355, [achv1]) ||
      pageUsesCode(pg, 355, [achv2]) ||
      pageUsesCode(pg, 655, [achv1]) ||
      pageUsesCode(pg, 655, [achv2])
    )
  }
  const eventUsesAch = function(event, ach) {
    if (!event) {return false}
    return event.pages.some(x=>pageUsesAch(x, ach))
  }
  DGT.MVDF.filters.event = {
    usesSwitch: eventUsesSwitch,
    usesVar: eventUsesVar,
    usesCode: eventUsesCode,
    usesAch: eventUsesAch
  }
  DGT.MVDF.filters.page = {
    usesSwitch: pageUsesSwitch,
    usesVar: pageUsesVar,
    usesCode: pageUsesCode,
    usesAch: pageUsesAch,
    general: pageUsesName
  }
}