{
  const style = document.createElement('style')
  style.id = 'data-finder-style'
  style.innerText = `
  * {box-sizing: border-box; margin: 0}
  a {color: aliceblue}
  .highlight {transition: background-color 0.5s linear; background-color: gray}

  #dfw {background-color: #404040; z-index: 143; position: absolute; display: flex; color: aliceblue; font-family: monospace;}
  #dfw {width: 640px; height: 480px; top: 50%; left: 50%; transform: translate(-50%, -50%)}
  #dfw > .right {background-color: var(--s2); display: flex; flex: 5 0 0; flex-direction: column;}
  .history {flex: 0 1 0; margin: 0.25rem; margin-bottom: 0;}
  .history > a {text-decoration: none}
  .history > a:hover {text-decoration: underline;}
  .history > span:last-of-type {display: none}
  .pages {margin: 0.5rem; margin-top: -0.5rem}
  .pages > .page-btn {background-color: var(--b1); color: aliceblue; border-radius: 0 0 5px 5px; border-color: var(--s2); border-top: none;}
  .pages > .page-btn.selected {background-color: var(--d2); border-color: aliceblue;}
  .code-view {overflow: auto; border: 1px solid var(--b1); border-radius: 5px; flex: 1 0 0; margin: 0.5rem auto; width: 27rem;}
  .code-view > div {width: max-content; min-width: 100%;}
  .code-view > div > div {background-color: var(--d1); align-items: center; display: flex; border-bottom: 1px solid var(--b1); min-height: 20px; padding: 2px 0; width: 100%;}
  .code-view > div > div:nth-child(2n+1) {background-color: var(--d2);}
  .code-view > div > div > p {margin: 0;}
  span.eventcode::before {content: "◆"; color: aliceblue;}
  
  body {--b1: #1C2122; --s1: #56595B; --s2: #474B4D; --d1: #242829; --d2: #2C2E30;}
  body {
    --flow: #5394EC;
    --noop: #90B775;
    --state: #FF8766;
    --party: #FF8C00;
    --pic: #DC56DF;
    --vfx: #D6BF46;
    --sfx: #A6DCDC;
    --delay: #FF6B68;
    --special: #DFBFFF;
    --eval: #9BB6CF;
    --move: #BF7070;
    --battle: #C19DD1;
  }

  #dfw > .left {background-color: var(--s1); display: flex; flex: 2 0 0; border-right: 2px solid var(--b1); display:flex; flex-direction: column; padding: 0.25rem}
  #dfw > .left > section {flex: 1 0 0; flex-direction: column; display: none;}
  #dfw > .left > section.active {flex: 1 0 0; display: flex;}
  #dfw > .left > input {flex: 0 0 20px; color: aliceblue; background-color: var(--d1); margin: 0.25rem}
  .code-view.truncate {width: 11rem;}
  .code-view.truncate > div {width: 100%;}
  .code-view.truncate > div > div {min-height: 22px;}
  .code-view.truncate > div > div > a {overflow: hidden; white-space: nowrap; text-overflow: ellipsis;}

  ::-webkit-scrollbar {width: 7px; height: 8px;}
  ::-webkit-scrollbar-track {background: #f1f1f1;}
  ::-webkit-scrollbar-thumb {background: #888;}
  ::-webkit-scrollbar-thumb:hover {background: #555;}
  ::-webkit-scrollbar-corner {background: #000;}
  `
  document.head.append(style)
}