var DGT = DGT || {}
DGT.MVDF = DGT.MVDF || {}
DGT.MVDF.data = {}
DGT.MVDF.view = {source:{}, code:{}, history:{}, page:{}}
DGT.MVDF.protocols = DGT.MVDF.protocols || {}
DGT.MVDF.symbols = DGT.MVDF.symbols || new Proxy({}, {get(obj,prop){if(!obj[prop]){obj[prop] = Symbol(prop)};return obj[prop]}})
// {DGT.MVDF.symbols = DGT.MVDF.symbols || {}; DGT.MVDF.symbols.cb = DGT.MVDF.symbols.cb || Symbol('cb'); DGT.MVDF.symbols.type = DGT.MVDF.symbols.type || Symbol('type'); DGT.MVDF.symbols.data = DGT.MVDF.symbols.data || Symbol('data'); DGT.MVDF.symbols.containsSources = DGT.MVDF.symbols.containsSources || Symbol('Is Source'); DGT.MVDF.symbols.hovertext = DGT.MVDF.symbols.hovertext || Symbol('Hover Text')}
// {DGT.MVDF.symbols.usesVar = DGT.MVDF.symbols.usesVar || Symbol('doesUseVariable'); DGT.MVDF.symbols.usesSwitch = DGT.MVDF.symbols.usesSwitch || Symbol('doesUseSwitch'); DGT.MVDF.symbols.usesCode = DGT.MVDF.symbols.usesCode || Symbol('doesUseCode');}
{
  const {cb, data, containsSources, hovertext, usesVar, usesSwitch, usesCode, usesAch, isHome, _data} = DGT.MVDF.symbols
  
  const NBSP = ' '
  const make = document.createElement.bind(document)
  const body = document.body

  let main = make('div')
  main.id = 'dfw'
  let leftColumn = make('div')
  leftColumn.className = 'left'
  main.append(leftColumn)
  
  let search = make('input')
  search.id = 'dfw-search'
  leftColumn.append(search)

  let dataSources = []
  let curDataSource = null
  function* prepend(a, b) {if (a) {yield a}; yield* b}
  function* squeezeSource(source) {
    if (source[containsSources]) {
      for (const src of source[data]()) {
        yield* squeezeSource(src)
      }
    } else {
      yield* source[data]()
    }
  }
  let helpSource = {
    name: 'Help',
    [_data]: ['Search by variable:', '- var:id', '- e.g. "var:22"', 'Search by switch:', '- switch:id', '- e.g. "switch:1682"', 'Search by achievement:', '- ach:id', '- e.g. "ach:welcome_home"', 'Search by id:', '- id', '- e.g. "120"', '', '--ADVANCED--', '', 'Hotkey E: Show ids on sources', '', 'Search by command code:', '- code:id,param1,param2,...', '- e.g. "code:356,StopEventMovement"'],
    [data]: function*() {yield* this[_data]},
    [cb]: function() {updateCodeView(this[data](), _=>_)}
  }
  helpSource[_data].push('', '<a href="#" data-fq="restartscenemanager:void">(EXPERIMENTAL) Click here to restart SceneManager and enter the game</a>')
  dataSources.push({
    name: 'Home',
    [isHome]: isHome,
    [containsSources]: true,
    [data]: function*() {yield* dataSources.filter(x=>x!==this); yield helpSource},
    [cb]: function() {updateSourceView(this)},
  })
  // dataSources.push({
  //   name: 'Everything',
  //   [containsSources]: true,
  //   [data]: function*() {
  //     for (const x of dataSources) {
  //       if (x.name !== 'Everything' &&
  //           x.name !== 'Home' &&
  //           x.name !== 'Help' &&
  //           x.name !== 'Settings') {
  //         yield* squeezeSource(x)
  //       }
  //     }
  //   },
  //   [cb]: function() {updateSourceView(this)},
  // })
  DGT.MVDF.data.sources = dataSources
  let sourceDiv = make('div')
  sourceDiv.className = 'code-view truncate'
  let sourceView = make('div')
  sourceDiv.append(sourceView)
  leftColumn.append(sourceDiv)

  function fill(view) {while (view.children.length < 25) {view.append(make('div'))}; view.append(make('div'))}
  function updateSourceView(source, keep, noSave, noUpdateFilter) {
    sourceDiv.scrollTop = 0
    if (!noSave) {curDataSource = source}
    if (!keep) {sourceView.innerHTML = ''}
    const home = source[isHome]===isHome?null:dataSources[0]
    for (const item of prepend(home, source[data]())) {
      const div = make('div')
      const a = make('a')
      a.href = '#'
      a.innerText = item.name
      a.onclick = item[cb].bind(item)
      if (item[hovertext]) {
        div.onmouseenter = function() {a.text = item[hovertext].padEnd(item.name.length, '-')}
        div.onmouseleave = function() {a.text = item.name}
      }
      div.append(a)
      sourceView.append(div)
    }
    fill(sourceView)
    if (!noUpdateFilter) {search.onblur()}
  }
  document.addEventListener('keydown', e=>{if (e.code === 'KeyE'){sourceView.querySelectorAll('div').forEach(a=>a.onmouseenter&&a.onmouseenter())}})
  document.addEventListener('keyup', e=>{if (e.code === 'KeyE'){sourceView.querySelectorAll('div').forEach(a=>a.onmouseleave&&a.onmouseleave())}})
  DGT.MVDF.view.source.updateCurrent = ()=>updateSourceView(curDataSource)
  DGT.MVDF.view.source.update = updateSourceView

  function filterCurSource(fn, ...args) {
    DGT.MVDF.view.source.update({
      name: 'Search Filter',
      [isHome]: curDataSource[isHome],
      [data]: function*(){let i = 0; for (const x of curDataSource[data]()) {if (fn(x, i, ...args)) {yield x}; i++}},
      [cb]: function() {updateSourceView(this)}
    }, false, true, true)
  }
  const symFind = sym => (x, _i, ...args) => x[sym]&&x[sym](...args)
  search.onblur = function() {
    let text = search.value
    search.style.borderColor = ''
    if (!text) {updateSourceView(curDataSource, false, true, true); return}
    if (text.match(/^code: ?(\d+),(.+)$/i)) {
      let code = RegExp.$1
      let params = RegExp.$2
      filterCurSource(symFind(usesCode), code, params.split(/, ?/))
    } else if (text.match(/^switch: ?(\d+)$/i)) {
      let id = RegExp.$1
      filterCurSource(symFind(usesSwitch), id)
    } else if (text.match(/^var(?:iable)?: ?(\d+)$/i)) {
      let id = RegExp.$1
      filterCurSource(symFind(usesVar), id)
    } else if (text.match(/^ach(?:ievement)?: ?(.*)$/i)) {
      let achievement = RegExp.$1
      filterCurSource(symFind(usesAch), achievement)
    } else if (!isNaN(parseInt(text))) {
      filterCurSource((x) => x&&(!x.id||x.id==parseInt(text)))
    } else {
      search.style.borderColor = '#FF0000'
    }
  }

  let rightColumn = make('div')
  rightColumn.className = 'right'
  main.append(rightColumn)
  let codeDiv = make('div')
  codeDiv.className = 'code-view'
  let codeView = make('div')
  codeDiv.append(codeView)
  let history = []
  function updateCodeView(items, mapFn, colorFn) {
    codeView.innerHTML = ''
    for (const item of items) {
      let div = make('div')
      let p = make('p')
      p.innerHTML = mapFn(item)
      if (colorFn) {
        p.style.color = colorFn(item)
      }
      p.querySelectorAll('a').forEach(a=>{
        a.onclick = handleLinkClick
        a.onmouseenter = handleLinkEnter
        a.onmouseleave = handleLinkLeave
      })
      div.append(p)
      codeView.append(div)
    }
    fill(codeView)
  }
  DGT.MVDF.view.code.update = updateCodeView

  let pageView = make('nav')
  pageView.className = 'pages'
  function clearPages() {
    pageView.innerHTML = ''
  }
  function addPage(label, callback, select) {
    let btn = make('button')
    btn.className = `page-btn${select?' selected':''}`
    btn.innerText = label
    btn.onclick = callback
    pageView.append(btn)
  }
  DGT.MVDF.view.page.clear = clearPages
  DGT.MVDF.view.page.add = addPage
  let historyView = make('nav')
  historyView.className = 'history'
  rightColumn.append(historyView)
  rightColumn.append(codeDiv)
  rightColumn.append(pageView)
  function storeScroll() {
    if (history.length > 0) {
      history[history.length-1].scrollTop = codeDiv.scrollTop
    }
  }
  DGT.MVDF.view.history.storeScroll = storeScroll
  function addHistory(name, callback) {
    clearPages()
    if (history.length > 0) {
      history[history.length-1].scrollTop = codeDiv.scrollTop
    }
    codeDiv.scrollTop = 0
    history.push({
      name,
      callback,
      scrollTop:null
    })
    historyView.innerHTML = ''
    for (const item of history) {
      let a = make('a')
      let p = make('span')
      a.href = '#'
      a.onclick = ()=>{
        rewindHistory(history.indexOf(item))
        item.callback()
        if (item.scrollTop) {
          codeDiv.scrollTop = item.scrollTop
        }
      }
      a.innerText = item.name
      p.innerText = NBSP + '>' + NBSP
      historyView.append(a, p)
    }
  }
  function clearHistory() {
    history = []
  }
  function rewindHistory(index) {
    history = history.slice(0, index)
  }
  function refreshHistory() {
    let last = history.pop()
    last.callback()
    if (last.scrollTop) {
      codeDiv.scrollTop = last.scrollTop
    }
  }
  DGT.MVDF.view.history.add = addHistory
  DGT.MVDF.view.history.clear = clearHistory
  DGT.MVDF.view.history.rewind = rewindHistory

  DGT.MVDF.protocols.var = (x)=>{search.value = `var: ${x}`; search.onblur(); refreshHistory()}
  DGT.MVDF.protocols.switch = (x)=>{search.value = `switch: ${x}`; search.onblur(); refreshHistory()}

  DGT.MVDF.protocols.langmsg = (id)=>{
    let msg
    try {
      msg = LanguageManager.getMessageData(id)
    } catch (e) {
      msg = {ERROR: "NO LANGUAGE DATA FOUND"}
    }
    DGT.MVDF.view.history.add(id, ()=>{})
    updateCodeView(Object.entries(msg), ([key, val])=>`--${key}: ${val}`)
  }
  const highlight = (e, ms=1500)=>{e.classList.add('highlight'); setTimeout(()=>e.classList.remove('highlight'), ms)}
  DGT.MVDF.protocols.label = (id)=>{
    let selectedLabel = codeView.querySelector('#'+id)
    if (selectedLabel) {selectedLabel.scrollIntoView(); highlight(selectedLabel)}
  }
  function handleLinkEnter() {
    this.dataset.origtext = this.innerText
    this.innerText = this.dataset.fq.padEnd(this.dataset.origtext.length, '-')
  }
  function handleLinkLeave() {
    this.innerText = this.dataset.origtext
  }
  function handleLinkClick() {
    let [protocol, id] = this.dataset.fq.split(/:(.*)/, 2)
    console.log(`REDIRECT to ${protocol} #${id}`)
    let protoFn = DGT.MVDF.protocols[protocol]
    if (protoFn) {
      protoFn(id)
    } else {
      console.log('unimplemented')
    }
  }

  body.append(main)
  updateSourceView(dataSources[0])
}