var DGT = DGT || {}
DGT.MVDF = DGT.MVDF || {}
DGT.MVDF.symbols = DGT.MVDF.symbols || new Proxy({}, {get(obj,prop){if(!obj[prop]){obj[prop] = Symbol(prop)};return obj[prop]}})
{
  const {cb, data, containsSources, hovertext, usesVar, usesSwitch, usesCode, usesAch, _data, isCevent} = DGT.MVDF.symbols

  const NBSP = ' '
  const translate = DGT.MVDF.translate.codes
  const params = translate.params
  const color = DGT.MVDF.translate.colors
  const paramsToString = function(p, code, selfvarlist) {
    if (DGT.MVDF.translate.defer[code]) {
      delete params[code]
      return DGT.MVDF.translate.defer[code](p, selfvarlist)
    }
    if (!params[code]) {
      params[code] = Array(p.length).fill('')
      if (p.length !== 0) {
        params[code][0] = 'Params: '
      }
    }
    while (params[code].length < p.length) {
      params[code].push('')
    }
    return p.map((x,i)=>params[code][i]+x).join(', ')
  }
  const codeToString = function(c, selfvarlist) {
    return `${NBSP.repeat(c.indent)}<span class="eventcode">${translate[c.code]||'C'+c.code} ${paramsToString(c.parameters, c.code, selfvarlist)}</span>`
  }
  function codeColor(c) {
    return color[c.code] || 'aliceblue'
  }
  const mapMetaExclude = ['data', 'events', 'pages', 'list']
  const mapMetaReadable = function([key, value]) {
    return `${key}: ${Array.isArray(value)?`[${value.join(', ')}]`:value}`
  }
  function* mapMetaData(map, layer=0, orig=map){
    for (let kv of Object.entries(map)) {
      if (!mapMetaExclude.includes(kv[0])) {
        if (DGT.MVDF.translate.meta[kv[0]]) {
          kv = DGT.MVDF.translate.meta[kv[0]](kv, orig)
        }
        kv[0] = '- '.repeat(layer) + kv[0]
        if (typeof kv[1] === 'object' && !Array.isArray(kv[1]) && kv[1] !== null) {
          yield [kv[0], '']
          yield* mapMetaData(kv[1], layer+1, orig)
        } else {
          yield kv
        }
      }
    }
  }
  let genCb = function(norewind, pg=0, same, orig) {
    if (norewind !== true && same !== true) {DGT.MVDF.view.history.rewind(0)}
    if (norewind !== true && same === true) {DGT.MVDF.view.history.rewind(-1)}
    DGT.MVDF.view.history.add(this.name, this[cb].bind(this, true, pg, false, orig))
    this.pages.forEach((e, i) => {
      DGT.MVDF.view.page.add(i, ()=>{this[cb](false, i, true)}, i===pg)
    })
    DGT.MVDF.view.page.add('event', ()=>{this[cb](false, -1, true)}, pg===-1)
    if (pg !== -1 && !this[isCevent]) {DGT.MVDF.view.page.add('page', ()=>{this[cb](false, -2, true, orig !== undefined ? orig : pg)}, pg===-2)}
    if (pg === -1) {
      DGT.MVDF.view.code.update(mapMetaData(this), mapMetaReadable.bind(this))
    } else if (pg === -2) {
      DGT.MVDF.view.code.update(mapMetaData(this.pages[orig]), mapMetaReadable.bind(this))
    } else {
      let selfvarlist = this.selfVariables
      DGT.MVDF.view.code.update(this.pages[pg].list, (c)=>codeToString(c, selfvarlist), codeColor)
    }
  }
  let genEvent = {
    [cb]: genCb,
    [usesVar]: function(id) {return DGT.MVDF.filters.event.usesVar(this, id)},
    [usesSwitch]: function(id) {return DGT.MVDF.filters.event.usesSwitch(this, id)},
    [usesCode]: function(id, param) {return DGT.MVDF.filters.event.usesCode(this, id, param)},
    [usesAch]: function(id) {return DGT.MVDF.filters.event.usesAch(this, id)}
  }
  let genSource = {
    [cb]: function() {DGT.MVDF.view.source.update(this)},
    [usesVar]: function(id) {return this[_data].some(x=>x&&x[usesVar](id))},
    [usesSwitch]: function(id) {return this[_data].some(x=>x&&x[usesSwitch](id))},
    [usesCode]: function(id, param) {return this[_data].some(x=>x&&x[usesCode](id, param))},
    [usesAch]: function(id) {return this[_data].some(x=>x&&x[usesAch](id))}
  }
  let oldOnLoad = DataManager.onLoad
  DataManager.onLoad = function(obj) {
    if (obj === $dataCommonEvents) {
      let ceventSource = {
        ...genSource,
        name: "Common Events",
        [_data]: $dataCommonEvents.map((event, eid)=>
            event?Object.assign(event, genEvent, {
              pages:[event], // cursed
              [isCevent]:true,
              [usesSwitch]: function(id) {return (this.trigger && this.switchId === parseInt(id))||genEvent[usesSwitch].call(this, id)},
              [hovertext]:`CEVENT #${eid}`
            }):null
        ),
        [data]: function() {return this[_data].filter(e=>e&&(e.list.length!==1||e.name))}
      }
      DGT.MVDF.data.sources.push(ceventSource)
      DGT.MVDF.protocols.cevent = (id)=>genCb.call(ceventSource[_data][id], true)
    }
    if (obj === $dataTroops) {
      let troopSource = {
        ...genSource,
        name: "Troops",
        [_data]: $dataTroops.map((troop, id)=>
          troop?Object.assign(troop, genEvent, {
            name:troop.name || '- NO TROOP NAME -',
            [hovertext]:`TROOP #${id}`,
          }):null
        ),
        [data]: function() {return this[_data].filter(e=>e)},
      }
      DGT.MVDF.data.sources.push(troopSource)
    }
    // if (obj === $dataMap) {
    //   let mapSource = {
    //     name: "Map",
    //     [_data]: $dataMap.events.map(event=>
    //       event?Object.assign({cb:genCb, type:'map'}, event):null
    //     ),
    //     data: function() {return this[_data].filter(e=>e)},
    //     cb: function() {
    //       DGT.MVDF.view.source.update(this)
    //       DGT.MVDF.view.code.update(mapMetaData(obj), mapMetaReadable)
    //     }
    //   }
    //   DGT.MVDF.data.sources.push(mapSource)
    // }
    window['Yanfly'] = window['Yanfly'] || {} // use yanflys preloaded maps if they exist
    Yanfly.PreloadedMaps = Yanfly.PreloadedMaps || []
    // if preloaded maps already exist, add the stuff to them
    function setupMap(map, name, id) {
      map.events.forEach((e, eid)=>{
        if (e) {Object.assign(e, genEvent, {name: e.name||'- NO EVENT NAME -', ['MAP ID']:id, ["MAP NAME"]:name, [hovertext]:`MAP #${id}, EVENT #${eid}`})}
      })
      return Object.assign(map,  genSource, {
        name,
        id,
        [_data]: map.events,
        [data]: function*() {for (const e of this[_data]) {if (e) {yield e}}},
        [cb]: function() {
          DGT.MVDF.view.source.update(this)
          DGT.MVDF.view.code.update(mapMetaData(map), mapMetaReadable)
        },
        [hovertext]:`MAP #${id}`
      })
    }
    if (obj === $dataMapInfos) {
      loadedMaps = Yanfly.PreloadedMaps.map((e, i)=>{
        if (e) {
          return setupMap(e, $dataMapInfos[i].name, i)
        }
      }).filter(e=>e)
      $dataMapInfos.forEach((e, id)=>{
        if (e) {
          DGT.MVDF.loadMapData(id, (map)=>{
            loadedMaps[id] = (setupMap(map, e.name, id))
            DGT.MVDF.view.source.updateCurrent()
          })
        }
      })
      let mapSource = {
        ...genSource,
        name: "Maps",
        [containsSources]: true,
        [_data]: loadedMaps,
        [data]: function() {return this[_data].filter(e=>e)}
      }
      DGT.MVDF.data.sources.push(mapSource)
    }
    DGT.MVDF.view.source.updateCurrent()
    return oldOnLoad.call(this, obj)
  }
}